#ifndef _QDP_TYPES
#define _QDP_TYPES

#ifndef __restrict__
#define __restrict__
#endif

#ifdef __cplusplus
extern "C" {
#endif

typedef struct QDP_prof_t {
  int count;
  double time;
  double comm_time;
  double math_time;
  double nsites;
  char *func;
  const char *caller;
  int line;
  struct QDP_prof_t *next;
} QDP_prof;

!ALLTYPES
typedef struct $QDPPCTYPE_struct $QDPPCTYPE;
!END

#ifdef __cplusplus
}
#endif

#endif
